void phantom_paint(void) {
	int c1,c2;
	if (P_paint==3) {//spray		
		for (c1=0;c1<2;c1++) {
			bubble *b0=new bubble();
			b0->time[1]=toc+1000; b0->size=.1+rndu->token()*.1; b0->G=-.1;
			memcpy(b0->mat->data,P->mat->data,64);
			memcpy(b0->col,P->col,12);
			for (c2=0;c2<3;c2++) b0->col[c2]+=rndn->token()*.1;
			b0->mot->data[3]=rndn->token()*.1;
			b0->mot->data[4]=rndn->token()*.1;
			b0->mot->data[5]=-.6-rndu->token()*.3;			
			array<int> *car=new array<int>();
			*car=*vertclose;
			b0->carrier=(void*)car;
			linked_ani.append(b0);
		}
	}
	if (P_paint==4) {//blow up		
		rocket *b0=new rocket();
		b0->time[1]=toc+5000;
		memcpy(b0->mat->data,P->mat->data,64);
		b0->mot->data[5]=-.6-rndu->token()*.3;
		b0->carrier=(void*)&p_layout[4];
		linked_ani.append(b0);		
	}
}

void phantom_signals(void) {
	int c1;
	float sig_sty=p_sty->filter(f_sty);	c_sty->record(sig_sty);
	//float sig_cir=p_cir->filter(f_cir);	c_cir->record(sig_cir);
	//printf("%f ",p_sty->filter(f_sty));
	if (P_ready<toc) {
		if (sig_sty>.29) {
			P_ready=toc+400;
			P_paint++; if (P_paint>3) P_paint=1; }
		if (sig_sty<-.28) {
			P_ready=toc+400;
			P_paint--; if (P_paint<1) P_paint=3; }
	}	
	/*glPlotArray(200,(array<float>*)p_sty,30,1,0,0);
	glPlotArray(200,(array<float>*)f_sty,30,0,1,0);
	glPlotArray( 50,(array<float>*)c_sty,100,0,0,1);
	glPlotArray(100,(array<float>*)p_cir,10,1,0,0);
	glPlotArray(50,(array<float>*)f_cir,30,0,1,0);
	glPlotArray(200,(array<float>*)c_cir,1,0,0,1);*/
}

void bubble_collide(bubble *buba) {//closest vertex to bubble	
	float pps[3],pvd=0,pvc;
	int c1,c2,cnt,rs;
	array<int> *car=(array<int>*)buba->carrier;
	memcpy(pps,&buba->mat->data[12],12);	
	//printf("%i",car->numel);
	rs=car->numel*rndu->token();	
	for (c1=rs;c1<car->numel;c1+=2) {//redundant code
		pvd=0;
		cnt=car->data[c1]*6+3;
		for (c2=0;c2<3;c2++) {//distance from buba to all close vertices
			pvc=vertices->data[cnt+c2]-pps[c2];
			pvd+=pvc*pvc;}
		if (pvd<.7) {			
			for (c2=0;c2<3;c2++) vertices->data[cnt-3+c2]=buba->col[c2];
			buba->time[1]=0; //time to die!
			return;
		}
	}
	for (c1=0;c1<rs;c1+=2) {//redundant code
		pvd=0;
		cnt=car->data[c1]*6+3;
		for (c2=0;c2<3;c2++) {//distance from buba to all close vertices
			pvc=vertices->data[cnt+c2]-pps[c2];
			pvd+=pvc*pvc;}
		if (pvd<.7) {			
			for (c2=0;c2<3;c2++) vertices->data[cnt-3+c2]=buba->col[c2];
			buba->time[1]=0; //time to die!
			break;
		}
	}


}

void phantom_closest(void) {//closest vertex to phantom
	float pps[3],pvd,pvc,pvm=100; //cur dist, compon / min dist / min index	
	int ct,c2,cnt=0,pvi=0,clo=0,rea=0;	//min index	
	memcpy(pps,&P->mat->data[12],12);	
	for (int c1=3;c1<vertices->numel;c1+=6) {
		pvd=0;
		for (c2=0;c2<3;c2++) {
			pvc=vertices->data[c1+c2]-pps[c2];
			pvd+=pvc*pvc;
		}
		if (pvd<P_radius) {	vertreach->data[rea]=cnt;
												vertreacd->data[rea]=pvd;
												rea++;}
		if (pvd<200) {vertclose->data[clo]=cnt; clo++;}
		if (pvd<pvm) {pvm=pvd; pvi=cnt;}
		cnt++;											//cnt carries vertex index
	}
	//vertreach->size[0]=rea;				//paint mode 2
	vertclose->size[0]=clo;				//paint mode 3
	vertclose->numel=clo;					//...
	char glt[5];
	sprintf(glt,"%i",clo);
	linked_label.append(new glLabelText(0,11,glt,fnt0));
	
	//some drawing routines
	if (P_paint==1) {//paint the closest vertex
		int pvi6=pvi*6;
		if (pvm<3) {
			glLineWidth(2);
			glBegin(GL_LINES);
				glColor3f(1,1,1);		glVertex3fv(pps);
				glColor3fv(P->col);	glVertex3fv(&vertices->data[pvi6+3]);
			glEnd();
			if (P->button) memcpy(&vertices->data[pvi6],P->col,12);
		}
	}
	else if (P_paint==2) {//paint the environment
		glLineWidth(1);
		glBegin(GL_LINES);
			for (c1=0;c1<rea;c1++) {
				glColor3f(1,1,1);		glVertex3fv(pps);
				glColor3fv(P->col);	glVertex3fv(&vertices->data[vertreach->data[c1]*6+3]);
			}	
		glEnd();
		P_enable_rotz=1;
		if (P->button) {			
			if (rea>0)
				for (c1=0;c1<rea;c1++) {//shade the environ
					float var=abs(rndn->token())*.1/(vertreacd->data[c1]+.1);
					for (c2=0;c2<3;c2++) 
						pps[c2]=(1-var)*vertices->data[vertreach->data[c1]*6+c2]+var*P->col[c2];
					memcpy(&vertices->data[vertreach->data[c1]*6],pps,12);
				}
			else {
				P_enable_rotz=0;				
				P_radius=(P->sty.z()-M_PI+.5)*3;
				if (P_radius<.01) P_radius=.01;
				glColor3f(.9,.9,.9);
				glLineWidth(1);
				glPushMatrix();
					glTranslatef(P->mat->data[12],P->mat->data[13],P->mat->data[14]);
					glutWireSphere(P_radius*.5,20,20);
				glPopMatrix();
			}
		}
	}
	P_closest=pvi*triList->size[0];
}

void phantom_haptics(void) {// @ 1000Hz !
	int c1,c2,curr,closest=P_closest;	
	bool hit=false;
	float world_[16];
	float single[15];
	float F=10,eps=.001;
	memcpy(world_,P->world,64);	
	gstVector world_pos=gstVector(world_[ 0],world_[ 1],world_[ 2])*P->pos.x()+
											gstVector(world_[ 4],world_[ 5],world_[ 6])*P->pos.y()+
											gstVector(world_[ 8],world_[ 9],world_[10])*P->pos.z()+
											gstVector(world_[12],world_[13],world_[14]);
	gstVector rhs,sol;
	while ((curr=triList->data[closest])>=0&&!hit) {
		memcpy(single,&haptics->data[curr*15],60);
		rhs=gstVector(world_pos.x()-single[9],world_pos.y()-single[10],world_pos.z()-single[11]);
		sol=gstVector(single[0],single[1],single[2])*rhs.x()+
				gstVector(single[3],single[4],single[5])*rhs.y()+
				gstVector(single[6],single[7],single[8])*rhs.z();
		if (-eps<=sol.x()&&-eps<=sol.y()&&sol.x()+sol.y()<=1+eps)
			if (-.6<sol.z()&&sol.z()<0) {
				hit=true;
				F=F*sol.z();
				P->force-=(gstVector(world_[ 0],world_[ 4],world_[ 8])*single[12]+
				           gstVector(world_[ 1],world_[ 5],world_[ 9])*single[13]+
				           gstVector(world_[ 2],world_[ 6],world_[10])*single[14])*F;								
			}
		closest++;
	}
	if (P_paint==3&&P->button) {//force induced when spraying
		P->force+=gstVector(P->transform(2,0),P->transform(2,1),P->transform(2,2))*.3;}
};
	
unsigned int listColorCube(int n,unsigned int hnd) {
	int c2;
	float f=1/(float)n;
	glNewList(hnd,GL_COMPILE);	
		glPushMatrix();
			glTranslatef(0,0,40);
			glScalef(5,5,5);
			glTranslatef(-.5,-.5,-.5);
			glBegin(GL_QUADS);
			for (int c1=0;c1<n;c1++)
				for (c2=0;c2<n;c2++) {
					glColor3f(c1*f,c2*f,0);
						glVertex3f( c1   *f, c2   *f,0);
						glVertex3f((c1+1)*f, c2   *f,0);
						glVertex3f((c1+1)*f,(c2+1)*f,0);
						glVertex3f( c1   *f,(c2+1)*f,0);				
					glColor3f(c1*f,0,c2*f);
						glVertex3f( c1   *f,0, c2   *f);				
						glVertex3f((c1+1)*f,0, c2   *f);				
						glVertex3f((c1+1)*f,0,(c2+1)*f);				
						glVertex3f( c1   *f,0,(c2+1)*f);				
					glColor3f(0,c1*f,c2*f);
						glVertex3f(0, c1   *f, c2   *f);				
						glVertex3f(0,(c1+1)*f, c2   *f);				
						glVertex3f(0,(c1+1)*f,(c2+1)*f);				
						glVertex3f(0, c1   *f,(c2+1)*f);
				}
			glEnd();
		glPopMatrix();
	glEndList();
	return hnd;
}